#!/usr/bin/env python
# Licensed to Cloudera, Inc. under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  Cloudera, Inc. licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import desktop.tests
import librdbms.conf


class TestDatabasePasswordConfig(desktop.tests.BaseTestPasswordConfig):

  def setup(self):
    self.finish = librdbms.conf.DATABASES.set_for_testing({'test': {}})

  def teardown(self):
    self.finish()

  def get_config_password(self):
    return librdbms.conf.DATABASES['test'].PASSWORD

  def get_config_password_file(self):
    return librdbms.conf.DATABASES['test'].PASSWORD_FILE

  def get_password(self):
    return librdbms.conf.get_database_password('test')
